/*
    Ajax Domain - Use Ajax to search for domains.
    Copyright (C) 2010-2012 WHMCS Addon

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Configuration
var cartLocation = 'cart.php'; // Where is your cart located?
var orderFormLocation = 'order/ajaxdomain.php'; // Where is your order form located?

// -- Special Elements :: Wrap <a></a> around text/elements you wish to link to the cart:
var transferString = '<img src="images/statusok.gif" /> <a>Transfer this domain...</a>' // What would you like to say if the domain is eligible for a transfer? 
var registerString = '<img src="images/statusok.gif" /> <a>Register this domain...</a>' // What would you like to say if the domain is eligible for a registration?
// -- End of Special Elements
var unavailable = '<img src="images/statusfailed.gif" /> This domain is unavailable';

var tableMode = false; // Would you like to check all available tlds? Displays the order/templates/ajaxdomain.tpl template file. Ignores transferString/registerString/unavailable variables above.

/*
	Regular Expression to determine if the domain is properly formatted. Add any additional tld's that are not included in the list below by adding |tld after the word museum.
	-- Any two letter tld is already included by defualt.
*/
domainReg = /^\w+([\.-]?\w+)*\.(\w{2}|(com|net|org|edu|int|mil|gov|arpa|biz|aero|name|coop|info|pro|museum))$/

// End of configurations

var adcurrentcheckcontent,adlastcheckcontent,ld,checkdomaintimer;

function ajaxdomainvalidatedomain() {
		
		if (tableMode == false) {
			jQuery.ajax({
				dataType: "jsonp",
				url: orderFormLocation,
				data: "a=ajaxRegister&domain="+adcurrentcheckcontent,
				success: function(data){
					
				},
				jsonp: "callback",
				jsonpCallback: 'ajaxdomainJSONP'
			});
			
		} else {
			jQuery.ajax({
				dataType: "jsonp",
				url: orderFormLocation,
				data: "a=ajaxRegisterAll&domain="+adcurrentcheckcontent,
				success: function(data){
					
				},
				jsonp: "callback",
				jsonpCallback: 'ajaxdomainJSONP'
			});

		}
}

function ajaxdomainJSONP(data) {	
	if (tableMode == false) {
		if (data.status == "unavailable") {
			if (data.transferenabled == "on" && data.transferoptionscount) {
				// Transfer Now...
				ld = adcurrentcheckcontent.split(".");
				jQuery("#ajaxdomainstatus").html(transferString.replace(/<a>/gi, '<a href="'+cartLocation+'?a=add&domain=transfer&sld='+ld[0]+'&tld=.'+ld[1]+'">')).slideDown();
			} else {
				jQuery("#ajaxdomainstatus").html(unavailable).slideDown();
				// Not Available...	
			}
		}
		
		if (data.status == "available") {
			if (data.regenabled == "on" && data.regoptionscount) {
				// Register Now...
				ld = adcurrentcheckcontent.split(".");
				jQuery("#ajaxdomainstatus").html(registerString.replace(/<a>/gi, '<a href="'+cartLocation+'?a=add&domain=register&sld='+ld[0]+'&tld=.'+ld[1]+'">')).slideDown();
			} else {
				jQuery("#ajaxdomainstatus").html(unavailable).slideDown();
			}
		}
	} else {
		jQuery("#ajaxdomainstatus").html(data.replace(/\[cartLocation\]/gi, cartLocation)).slideDown();
	}
}
function ajaxdomaincheckdomainentry() {
    adcurrentcheckcontent = jQuery("#ajaxdomain").val();
    if (adcurrentcheckcontent!=adlastcheckcontent && domainReg.test(adcurrentcheckcontent)) {
        ajaxdomainvalidatedomain();
		jQuery("#ajaxdomainstatus").slideUp();
        adlastcheckcontent = adcurrentcheckcontent;
	} else if (adcurrentcheckcontent!=adlastcheckcontent) {
		jQuery("#ajaxdomainstatus").slideUp();
		adlastcheckcontent = adcurrentcheckcontent;
	}
    checkdomaintimer = setTimeout('ajaxdomaincheckdomainentry();', 3000);
}

jQuery("#ajaxdomain").live("change", function() {
	clearTimeout(checkdomaintimer);	
	jQuery("#ajaxdomainstatus").slideUp();
	checkdomaintimer = setTimeout('ajaxdomaincheckdomainentry();', 3000);
}).live("keypress", function(event){
	if (event.which == '13') {
	 clearTimeout(checkdomaintimer);	
	 ajaxdomaincheckdomainentry();
   }
	
});

ajaxdomaincheckdomainentry();